//----------------------------------------------------------------
/* Thirteen Down
/*   Written by Azuron 1992 8.28(Fri.)
/* Oh!X 1992/11
// V3.20以降専用
//----------------------------------------------------------------

// iPadのみ
if not checkCompatible(COMPATIBLE_IPAD) then stop

if cardInit()<>0 then {
	print localizedString("カードパターンが読めません","Card data can not read.")
	end
}

//----------------------------------------------------------------
// 以下ゲーム実体
//----------------------------------------------------------------
// お約束部分
enum
	FNTSZ=16
	KEY_SPACE=' '
endenum
str FONT="Migu-1M-Regular"

int gwx,gwy
width(0)
getWidth(gwx,gwy)

font(FONT,FNTSZ):// 先にフォントを設定してからwidth()を設定する
width(96):// テキスト文字フォントサイズを算出させる
// 以下テキスト描画はグラフィックモードで行う(X68のプログラムのままではグラフィックとテキストで座標が合わないので)
width(0)
tAtrb(ATRB_CLEAR):// グラフィックモードでテキスト文字の下地を消す

vpriority(TPAGE,GPAGE0,GPAGE1,GPAGE2,GPAGE3)
vpage(B_TPAGE+B_GPAGE0+B_GPAGE1+B_GPAGE2+B_GPAGE3)

// bitmapOpen()はページ毎に行う必要がある
apage(GPAGE3):bitmapOpen(0,0,YES)
apage(GPAGE2):bitmapOpen(0,0,YES)
apage(GPAGE1):bitmapOpen(0,0,YES)
apage(GPAGE0):bitmapOpen(0,0,YES)

// これがないと任意のタッチ座標を得られない / Need for getting any touch coordinate
setTouchArea(0,0,0,0,0,NO)

dim int	touchNo(20)	:// タッチエリア番号 / touch area number
int touchallcnt=0	:// タッチエリア数   / the number of touch area

//----------------------------------------------------------------

int i,j,r,yp,hp,sp,bc,kazu,tm,dead,level
int d_card,nothing,endflg=0,strong=0,down=0
dim int cd(52),hd(30),yb(13),ba(8),da(4),dp(4),sute(30)
dim int bx(8)={24,76,128,180,284,336,388,440}
/*
// 音声データ読み込み
int pasa=a_setPlayData("13d-1.mp3")
int chin=a_setPlayData("13d-2.mp3")
int tero=a_setPlayData("13d-3.mp3")
/*
level=level_select()
prep()
/*
repeat
	shuffle(1,52)
	vinit()
	layout()
	repeat
		r=select()
	until (r<>0 or endflg<>0)
	ending(r)
	Go_on(r)
	again()
until endflg
/*

// 音声バッファー開放
a_end(pasa)
a_end(chin)
a_end(tero)

// bitmapはページごとに確保されているので、それぞれを開放する必要がある
apage(GPAGE3):bitmapClose()
apage(GPAGE2):bitmapClose()
apage(GPAGE1):bitmapClose()
apage(GPAGE0):bitmapClose()

end
/*
//----------------------------------------------------------------

func int select()
int n,mx,my,r=0
	// 離されるまで待つ
	while getTouchStatus()<>TOUCH_NONE
	endwhile

	// タッチされるまで待つ
	repeat
	until getTouchStatus()<>TOUCH_NONE

	dim float tpoint(1)
	int touchCnt=getTouchPoint(tpoint)
	mx=tpoint(0)
	my=tpoint(1)

	apage(GPAGE3)
	n=bitmapPoint(mx,my)
	if (my<20 and n<>0) then n=n+15
	/*
	switch n
		case 0
		case 10:case 11:case 12:case 13
			break
		case 9
			yobi_open()
			break
		case 14
			if nothing then r=seiri() else hand_open()
			break
		case 15
			sute_use()
			break
		case 16
			if retry() then r=3
			break
		case 17
			if quit() then endflg=1
			break
		default
			ba_move(n-1)
			break
	endswitch
	/*
	if endcheck() then r=2
	return(r)
endfunc
/*
//----------------------------------------------------------------

func hand_open()
dim int xx(5)={124,124,124,124,130}
dim str m(5) ={"NEXT","NEXT","NEXT","NEXT","END"}
/*
	apage(GPAGE0)
	cardPut(124,110,hd(hp),NO)
	number(140,210,kazu-hp-1)
	if hp>=kazu-1 then {
		if level=2 then xx(2)=xx(4):m(2)=m(4)
		if level=3 then xx(0)=xx(4):m(0)=m(4)
		apage(GPAGE1)
//		fill16X68(124,110,171,205,0)
		fill16X68(122-2,110,172+2,205,0)
		flbx(   122,144,172,170,14,15)
		symbol16X68(xx(tm-1),146,m(tm-1),1.5,15,FONT,FNTSZ)
		nothing=1
	}
	r=card_move(0,148,158)
	switch r
		case -1
			erase(GPAGE0):number(140,210,kazu-hp)
			if nothing then {
				apage(GPAGE1)
				fill16X68(122-2,144-2,172+2,170+2,0)
				cardPut(124,110,0,NO)
				nothing=0
			}
			break
		default
			if sp=0 and (kazu-1)=hp then {
				apage(GPAGE1)
				fill16X68(123,145,171,169,14)
				symbol16X68(xx(2),146,m(2),2,15,FONT,FNTSZ)
			}
			hp=hp+1
			break
	endswitch
endfunc
/*
//----------------------------------------------------------------

func yobi_open()
int p,f=1,x=248,y=498
	for p=0 to 7
		if ba(p)=0 then f=0:break
	next
	while f=0 and yp<>13
		apage(GPAGE0)
		cardPut(232,402,yb(yp),NO)
		number(x,y,13-yp-1)
		if yp=12 then {
			apage(GPAGE1)
			fill16X68(232,402,279,497,0)
		}
		p=card_move(2,254,450)
		if p=-1 then erase(GPAGE0):number(x,y,13-yp) else yp=yp+1
		break
	endwhile
endfunc
/*
//----------------------------------------------------------------

func ba_move(p)
int x,r
	while ba(p)
		x=bx(p)
		apage(GPAGE1):fill16X68(x,402,x+47,497,0)
		apage(GPAGE0):  cardPut(x,402,ba(p),NO)
		bc=ba(p):ba(p)=0
		r=card_move(1,x+24,450)
		while r
			ba_put(0,p,bc)
			break
		endwhile
		break
	endwhile
endfunc
/*
//----------------------------------------------------------------

func int sute_use()
int x
	if sp=0 then return(-1)
	x=(sp-1)*8+6
	apage(GPAGE1)
	fill16X68(x,272,x+47,367,0)
	if sp<>1 then sute_put(0,x-8,sute(sp-2))
	apage(GPAGE0)
	cardPut(x,272,sute(sp-1),NO)
	r=card_move(3,x+24,320)
	switch r
		case -1:
			erase(GPAGE0)
			sute_put(0,x,sute(sp-1))
			break
		default
			sp=sp-1
	endswitch
	return(0)
endfunc
/*
//----------------------------------------------------------------

func card_move(sw,zx,zy)
int n,mx,my,hx,hy,r
	apage(GPAGE0)
	repeat
		dim float tpoint(1)
		int touchCnt=getTouchPoint(tpoint)
		mx=tpoint(0)
		my=tpoint(1)
		//
		if mx<zx then hx=0 else hx=gwx://511
		if my<zy then hy=0 else hy=gwy://511
//		locate(0,25):print hx+zx-mx,hy+zy-my
//		gTransform(hx+zx-mx,hy+zy-my)
		gTransform(-(zx-mx),-(zy-my))
	until getTouchStatus()=TOUCH_NONE
	//
	apage(GPAGE3)
	r=destination(sw,bitmapPoint(mx,my))
	return(r)
endfunc
/*
/*
//----------------------------------------------------------------

func int destination(sw,p)
int r=-1
	switch sw
		case 0
			if p>9 and p<14 then r=da_card(p-10,hd(hp)):break
			if p=15 then suteru():r=0
			break
		
		case 1
			if p>0 and p<9  then r=ba_put(1,p-1,bc):break
			if p>9 and p<14 then r=da_card(p-10,bc)
			break
		
		case 2
			if p>0 and p<9 then {
				if ba(p-1)=0 then ba_put(1,p-1,yb(yp)):r=0
				break
			}
			if p>9 and p<14 and strong=0 then r=da_card(p-10,yb(yp))
			break
		
		case 3
			if p>9 and p<14 then r=da_card(p-10,sute(sp-1))
			break
	endswitch
	return(r)
endfunc
/*
//----------------------------------------------------------------

func int da_card(p,c)
int r=0
	if d_check(p,c) then r=-1 else da_put(p,c)
	return(r)
endfunc
/*
//----------------------------------------------------------------

func suteru()
	erase(GPAGE0)
	sute_put(1,sp*8+6,hd(hp))
	sute(sp)=hd(hp)
	sp=sp+1
endfunc
/*
//----------------------------------------------------------------

func int seiri()
int r=-1
	while(tm<>dead) and sp<>0
		apage(GPAGE1)
		fill16X68(122-2,144-2,172+2,170+2,0)
		fill16X68(  6,272,285,367,0)
		for i=0 to sp-1:cd(i)=sute(i):next
		shuffle(0,sp)
		for i=0 to sp-1:hd(i)=cd(i)  :next
		kazu=sp:hp=0:sp=0
		tm=tm+1
		nothing=0
		cardPut(124,110,0,NO):SE(pasa)
		number(140,210,kazu-hp)
		r=0
		break
	endwhile
	return(r)
endfunc
/*
//----------------------------------------------------------------

func number(x,y,n)
str s
	s=itoa(n)
	apage(GPAGE1)
	fill16X68(x-1,y-1,x+15+1,y+13+1,0)
	symbol16X68(x+(2-len(s))*4,y,s,1,15,FONT,FNTSZ)
endfunc
/*
//----------------------------------------------------------------

func layout()
	apage(GPAGE1):cardPut(232,402,0,NO):SE(pasa)
	number(248,498,13-yp)
	for i=0 to 7
		cardPut(bx(i),402,ba(i),NO):SE(pasa)
	next
	cardPut(292, 34,da(0),NO):SE(pasa)
	cardPut(124,110,0    ,NO):SE(pasa)
	number(140,210,30-hp)
endfunc
/*
//----------------------------------------------------------------

func int d_check(p,c2)
int d,c1,f=1
dim int s(2)={1,-1},A(4)={13,1,1,13}
	d=down
	while 1
		c1=da(p)
		if(d_card=rank(c2)) and da(p)=0 then f=0:break
		if suit(c1)<>suit(c2) then break
		c1=rank(c1):c2=rank(c2)
		if (c2-c1=s(d)) or (c1=A(d*2) and c2=A(d*2+1)) then f=0
		break
	endwhile
	return(f)
endfunc
/*
//----------------------------------------------------------------

func da_put(p,c)
int x,y
	erase(GPAGE0)
	apage(GPAGE1)
	x=p*56+292
	y=dp(p)*22+34
	cardPut(x,y,c,NO)
	line16X68(x+1,y,x+46,y,1)
	SE(chin)
	da(p)=c
	dp(p)=dp(p)+1
endfunc
/*
//----------------------------------------------------------------

func int ba_put(sw,p,c)
int f=0
	if ba(p) then f=1
	while f=0
		erase(GPAGE0)
		apage(GPAGE1)
		cardPut(bx(p),402,c,NO)
		if sw then SE(pasa)
		ba(p)=c
		break
	endwhile
	return(f)
endfunc
/*
//----------------------------------------------------------------

func sute_put(sw,x,c)
	apage(GPAGE1)
	cardPut(x,272,c,NO)
	line16X68(x,272,x,367,1)
	if sw then SE(pasa)
endfunc
/*
//----------------------------------------------------------------

func Go_on(r)
	if r=3 or endflg<>0 then return()
	//
	dim str menues(1)
	str title$
	if isLocalizeJapan() then {
		title$="続けますか？"
		menues={"はい","いいえ"}
	} else {
		title$="Continue?"
		menues={"Yes","No"}
	}
	int ret
	repeat
		ret=selectMenu2(title$,menues)
	until ret>=0:// メニュー内タッチを待つ
	switch ret
		case 0
			break
		case 1
			endflg=1
			break
	endswitch
endfunc
/*
//----------------------------------------------------------------

func int retry()
	dim str menues(1)
	str title$
	if isLocalizeJapan() then {
		title$="再挑戦しますか？"
		menues={"はい","いいえ"}
	} else {
		title$="Retry?"
		menues={"Yes","No"}
	}
	int ret
	repeat
		ret=selectMenu2(title$,menues)
	until ret>=0:// メニュー内タッチを待つ
	switch ret
		case 0
			r=1
			break
		case 1
			r=0
			break
	endswitch
	apage(GPAGE0)
	wipe()
	return(r)
endfunc
/*
//----------------------------------------------------------------

func int quit()
	dim str menues(1)
	str title$
	if isLocalizeJapan() then {
		title$="終了しますか？"
		menues={"はい","いいえ"}
	} else {
		title$="Exit?"
		menues={"Yes","No"}
	}
	int ret
	repeat
		ret=selectMenu2(title$,menues)
	until ret>=0:// メニュー内タッチを待つ
	switch ret
		case 0
			r=1
			break
		case 1
			r=0
			break
	endswitch
	apage(GPAGE0)
	wipe()
	return(r)
endfunc
/*
//----------------------------------------------------------------

func int endcheck()
	return((dp(0)+dp(1)+dp(2)+dp(3)=52))
endfunc
/*
//----------------------------------------------------------------

func flbx(x0,y0,x1,y1,c0,c1)
	fill16X68(x0,y0,x1,y1,c0)
	box16X68( x0,y0,x1,y1,c1)
endfunc
/*
//----------------------------------------------------------------

func erase(p)
	apage(p)
	wipe()
	gTransform(0,0):// 平行移動キャンセル
endfunc
/*
//----------------------------------------------------------------

func vinit()
	for i= 0 to 12:yb(i)   =cd(i):next
	for i=13 to 20:ba(i-13)=cd(i):next
	for i=22 to 51:hd(i-22)=cd(i):next
	da(0)=cd(21):da(1)=0:da(2)=0:da(3)=0
	dp(0)=1:dp(1)=0:dp(2)=0:dp(3)=0
	d_card=rank(cd(21))
	yp=0:hp=0:sp=0:kazu=30:tm=1:nothing=0
endfunc
/*
//----------------------------------------------------------------

func SE(t) /* Sound Effect
	a_play(t)
	repeat:until a_stat(t)=0
endfunc
/*
//----------------------------------------------------------------

func int rank(c)
	return ((c-1) mod 13+1)
endfunc
/*
//----------------------------------------------------------------

func int suit(c)
	return((c-1)\13)
endfunc
/*
//----------------------------------------------------------------

func shuffle(sw,max)
int i,a,b,c
	if sw then for i=0 to 51:cd(i)=i+1:next
	for i=1 to 199
		a=rand() mod max
		b=rand() mod max
		c=cd(a):cd(a)=cd(b):cd(b)=c
	next
endfunc
/*
//----------------------------------------------------------------

func ending(r)
	if r<>2 then return(r)
	apage(GPAGE0)
	flbx(150,228,367,291,8,9)
	symbol16X68(160,234,"Congratulations!",2,15,FONT,FNTSZ)
	hitKey(NO)
	fill16X68(150,228,360,299,0)
endfunc
/*
//----------------------------------------------------------------

func again()
	apage(GPAGE1)
	fill16X68(122,110,173,223,0)
	fill16X68(  6,272,285,367,0)
	fill16X68( 24,402,487,511,0)
	fill16X68(292, 32,507,397,0)
endfunc
/*
//----------------------------------------------------------------

func int level_select()
int c
	dim str menues(2)
	str title$
	if isLocalizeJapan() then {
		title$="レベル選択"
		menues={"簡単","普通","難しい"}
	} else {
		title$="Select level"
		menues={"Easy","Normal","Hard"}
	}
	int ret
	repeat
		ret=selectMenu2(title$,menues)
	until ret>=0:// メニュー内タッチを待つ
	switch ret
		case 0
			c=1
			break
		case 1
			c=2
			break
		case 2
			c=3
			break
	endswitch
	dead=(3-c)*2+1
	return(c)
endfunc
/*
//----------------------------------------------------------------

func prep()
	srand(val(mid$(time$,4,2)+right$(time$,2)))
	vpage(0)
	setgPalet16X68( 0,x68Color2iOSColor(12288))
	setgPalet16X68( 1,&h000000ff)
	setgPalet16X68(13,x68Color2iOSColor(65472))
	setgPalet16X68(14,x68Color2iOSColor(33824))
	setgPalet16X68(15,x68Color2iOSColor(65534))
	erase(GPAGE0)
	erase(GPAGE1)
	symbol16X68(180,2,"Thirteen Down",2,12,FONT,FNTSZ)
	symbol16X68(178,0,"Thirteen Down",2,13,FONT,FNTSZ)
	symbol16X68(132, 86,localizedString("手札","Hand"),1,15,FONT,FNTSZ)
	if isLocalizeJapan() then {
		symbol16X68(126,248,"捨て札",1,15,FONT,FNTSZ)
	} else {
		symbol16X68(126,248,"Discard",0.8,15,FONT,FNTSZ)
	}
	symbol16X68(231,382,localizedString("予備札","Spare"),1,15,FONT,FNTSZ)
	apage(GPAGE2)
	for i=0 to 3
		box16X68(i*56+290,30,i*56+340,397,11)
	next
	box16X68(4,268,287,370,13)
	flbx( 0 ,0, 47,19,2,3)
	flbx(464,0,511,19,2,3)
	symbol16X68(  4,2,"retry",1,15,FONT,FNTSZ)
	symbol16X68(473,2,"exit" ,1,15,FONT,FNTSZ)
	/*
	/* GPAGE3は仮想画面なので色変換不要
	apage(GPAGE3)
	for i=0 to7
		gColor(i+1)
		fill(bx(i),402,bx(i)+47,497)
	next
	gColor(9)
	fill(232,402,279,497)
	for i=0 to 3
		gColor(i+10)
		fill(i*56+290,30,i*56+340,397)
	next
	gColor(14):fill(122,108,173,207)
	gColor(15):fill(  2,270,287,367)
	gColor( 1):fill(  0,  0, 47, 19)
	gColor( 2):fill(404,  0,511, 19)
	//
	vpageX68(7)
endfunc

//****************************************************************
// 補助関数
//****************************************************************

func removeKeys()
// 全タッチアリアの解除 / release all key touch area
// 毎回変わるので重要 / Important because stage is changed every time
	if touchallcnt>0 then {
		int i
		for i=1 to touchallcnt
			removeTouchArea(touchNo(i))
		next
		touchallcnt=0:// 登録してないの印
	}:// すでに解除済みの時は何もしない / if already released, do nothing.
endfunc

//****************************************************************
